Index: /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.Designer.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.Designer.cs	(revision 2546)
@@ -0,0 +1,167 @@
+﻿namespace HeuristicLab.Optimizer {
+  partial class NewItemDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(NewItemDialog));
+      this.okButton = new System.Windows.Forms.Button();
+      this.cancelButton = new System.Windows.Forms.Button();
+      this.itemsListView = new System.Windows.Forms.ListView();
+      this.nameColumnHeader = new System.Windows.Forms.ColumnHeader();
+      this.descriptioncolumnHeader = new System.Windows.Forms.ColumnHeader();
+      this.itemsLabel = new System.Windows.Forms.Label();
+      this.showIconsCheckBox = new System.Windows.Forms.CheckBox();
+      this.showDetailsCheckBox = new System.Windows.Forms.CheckBox();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.SuspendLayout();
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Enabled = false;
+      this.okButton.Location = new System.Drawing.Point(456, 409);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 2;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      this.okButton.Click += new System.EventHandler(this.okButton_Click);
+      // 
+      // cancelButton
+      // 
+      this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.cancelButton.Location = new System.Drawing.Point(537, 409);
+      this.cancelButton.Name = "cancelButton";
+      this.cancelButton.Size = new System.Drawing.Size(75, 23);
+      this.cancelButton.TabIndex = 3;
+      this.cancelButton.Text = "&Cancel";
+      this.cancelButton.UseVisualStyleBackColor = true;
+      // 
+      // itemsListView
+      // 
+      this.itemsListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.itemsListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.nameColumnHeader,
+            this.descriptioncolumnHeader});
+      this.itemsListView.HideSelection = false;
+      this.itemsListView.Location = new System.Drawing.Point(12, 33);
+      this.itemsListView.MultiSelect = false;
+      this.itemsListView.Name = "itemsListView";
+      this.itemsListView.Size = new System.Drawing.Size(600, 370);
+      this.itemsListView.TabIndex = 1;
+      this.itemsListView.UseCompatibleStateImageBehavior = false;
+      this.itemsListView.View = System.Windows.Forms.View.SmallIcon;
+      this.itemsListView.SelectedIndexChanged += new System.EventHandler(this.itemTypesListView_SelectedIndexChanged);
+      this.itemsListView.DoubleClick += new System.EventHandler(this.itemTypesListView_DoubleClick);
+      // 
+      // nameColumnHeader
+      // 
+      this.nameColumnHeader.Text = "Name";
+      // 
+      // descriptioncolumnHeader
+      // 
+      this.descriptioncolumnHeader.Text = "Description";
+      // 
+      // itemsLabel
+      // 
+      this.itemsLabel.AutoSize = true;
+      this.itemsLabel.Location = new System.Drawing.Point(12, 9);
+      this.itemsLabel.Name = "itemsLabel";
+      this.itemsLabel.Size = new System.Drawing.Size(35, 13);
+      this.itemsLabel.TabIndex = 0;
+      this.itemsLabel.Text = "&Items:";
+      // 
+      // showIconsCheckBox
+      // 
+      this.showIconsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.showIconsCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
+      this.showIconsCheckBox.Checked = true;
+      this.showIconsCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
+      this.showIconsCheckBox.Image = ((System.Drawing.Image)(resources.GetObject("showIconsCheckBox.Image")));
+      this.showIconsCheckBox.Location = new System.Drawing.Point(558, 3);
+      this.showIconsCheckBox.Name = "showIconsCheckBox";
+      this.showIconsCheckBox.Size = new System.Drawing.Size(24, 24);
+      this.showIconsCheckBox.TabIndex = 4;
+      this.toolTip.SetToolTip(this.showIconsCheckBox, "Show Icons");
+      this.showIconsCheckBox.UseVisualStyleBackColor = true;
+      this.showIconsCheckBox.Click += new System.EventHandler(this.showIconsCheckBox_Click);
+      // 
+      // showDetailsCheckBox
+      // 
+      this.showDetailsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.showDetailsCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
+      this.showDetailsCheckBox.Image = ((System.Drawing.Image)(resources.GetObject("showDetailsCheckBox.Image")));
+      this.showDetailsCheckBox.Location = new System.Drawing.Point(588, 3);
+      this.showDetailsCheckBox.Name = "showDetailsCheckBox";
+      this.showDetailsCheckBox.Size = new System.Drawing.Size(24, 24);
+      this.showDetailsCheckBox.TabIndex = 5;
+      this.toolTip.SetToolTip(this.showDetailsCheckBox, "Show Details");
+      this.showDetailsCheckBox.UseVisualStyleBackColor = true;
+      this.showDetailsCheckBox.Click += new System.EventHandler(this.showDetailsCheckBox_Click);
+      // 
+      // NewItemDialog
+      // 
+      this.AcceptButton = this.okButton;
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.CancelButton = this.cancelButton;
+      this.ClientSize = new System.Drawing.Size(624, 444);
+      this.Controls.Add(this.showDetailsCheckBox);
+      this.Controls.Add(this.showIconsCheckBox);
+      this.Controls.Add(this.itemsLabel);
+      this.Controls.Add(this.itemsListView);
+      this.Controls.Add(this.cancelButton);
+      this.Controls.Add(this.okButton);
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "NewItemDialog";
+      this.ShowIcon = false;
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+      this.Text = "New Item";
+      this.TopMost = true;
+      this.Load += new System.EventHandler(this.NewItemDialog_Load);
+      this.Shown += new System.EventHandler(this.NewItemDialog_Shown);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button okButton;
+    private System.Windows.Forms.Button cancelButton;
+    private System.Windows.Forms.ListView itemsListView;
+    private System.Windows.Forms.Label itemsLabel;
+    private System.Windows.Forms.CheckBox showIconsCheckBox;
+    private System.Windows.Forms.CheckBox showDetailsCheckBox;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.ColumnHeader nameColumnHeader;
+    private System.Windows.Forms.ColumnHeader descriptioncolumnHeader;
+  }
+}
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs	(revision 2546)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs	(revision 2546)
@@ -0,0 +1,97 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimizer {
+  internal partial class NewItemDialog : Form {
+    private bool initialized;
+    private List<IItem> items;
+
+    private IItem item;
+    public IItem Item {
+      get { return item; }
+    }
+
+    public NewItemDialog() {
+      initialized = false;
+      items = new List<IItem>();
+      item = null;
+      InitializeComponent();
+    }
+
+    private void NewItemDialog_Load(object sender, EventArgs e) {
+      if (!initialized) {
+        SetListViewDisplayStyleCheckBoxes();
+
+        DiscoveryService ds = new DiscoveryService();
+        var categories = from t in ds.GetTypes(typeof(IItem))
+                         where CreatableAttribute.IsCreatable(t)
+                         orderby CreatableAttribute.GetCategory(t), ItemAttribute.GetName(t) ascending
+                         group t by CreatableAttribute.GetCategory(t) into c
+                         select c;
+
+        itemsListView.SmallImageList = new ImageList();
+        foreach (var category in categories) {
+          ListViewGroup group = new ListViewGroup(category.Key);
+          itemsListView.Groups.Add(group);
+          foreach (var creatable in category) {
+            IItem i = (IItem)Activator.CreateInstance(creatable);
+            items.Add(i);
+            ListViewItem item = new ListViewItem(new string[] { i.Name, i.Description}, group);
+            itemsListView.SmallImageList.Images.Add(i.Image);
+            item.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+            item.Tag = i;
+            itemsListView.Items.Add(item);
+          }
+        }
+        initialized = true;
+      }
+    }
+
+    private void NewItemDialog_Shown(object sender, EventArgs e) {
+      item = null;
+    }
+
+    private void itemTypesListView_SelectedIndexChanged(object sender, EventArgs e) {
+      okButton.Enabled = itemsListView.SelectedItems.Count == 1;
+    }
+
+    private void okButton_Click(object sender, EventArgs e) {
+      if (itemsListView.SelectedItems.Count == 1) {
+        item = (IItem)((IItem)itemsListView.SelectedItems[0].Tag).Clone();
+        DialogResult = DialogResult.OK;
+        Close();
+      }
+    }
+    private void itemTypesListView_DoubleClick(object sender, EventArgs e) {
+      if (itemsListView.SelectedItems.Count == 1) {
+        item = (IItem)((IItem)itemsListView.SelectedItems[0].Tag).Clone();
+        DialogResult = DialogResult.OK;
+        Close();
+      }
+    }
+
+    private void showIconsCheckBox_Click(object sender, EventArgs e) {
+      itemsListView.View = View.SmallIcon;
+      SetListViewDisplayStyleCheckBoxes();
+    }
+    private void showDetailsCheckBox_Click(object sender, EventArgs e) {
+      itemsListView.View = View.Details;
+      SetListViewDisplayStyleCheckBoxes();
+      for (int i = 0; i < itemsListView.Columns.Count; i++)
+        itemsListView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+    }
+    private void SetListViewDisplayStyleCheckBoxes() {
+      showIconsCheckBox.Checked = itemsListView.View == View.SmallIcon;
+      showDetailsCheckBox.Checked = itemsListView.View == View.Details;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/NewToolBarItem.cs	(revision 2546)
@@ -10,17 +10,14 @@
 
 namespace HeuristicLab.Optimizer {
-  public class NewToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class NewToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "New..."; }
     }
-
     public override string ToolTipText {
       get { return "New Item (Ctrl + N)"; }
     }
-
     public override int Position {
       get { return 10; }
     }
-
     public override Image Image {
       get { return Resources.NewIcon; }
@@ -28,5 +25,5 @@
 
     public override void Execute() {
-      Actions.NewAction.Execute();
+      FileManager.New();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/OpenToolBarItem.cs	(revision 2546)
@@ -10,17 +10,14 @@
 
 namespace HeuristicLab.Optimizer {
-  public class OpenToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class OpenToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Open..."; }
     }
-
     public override string ToolTipText {
       get { return "Open File (Ctrl + O)"; }
     }
-
     public override int Position {
       get { return 20; }
     }
-
     public override Image Image {
       get { return Resources.OpenIcon; }
@@ -28,5 +25,5 @@
 
     public override void Execute() {
-      Actions.OpenAction.Execute();
+      FileManager.Open();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveAllToolBarItem.cs	(revision 2546)
@@ -10,23 +10,27 @@
 
 namespace HeuristicLab.Optimizer {
-  public class SaveAllToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SaveAllToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Save All"; }
     }
-
     public override string ToolTipText {
       get { return "Save All Files"; }
     }
-
     public override int Position {
       get { return 40; }
     }
-
     public override Image Image {
       get { return Resources.SaveAllIcon; }
     }
 
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      ToolStripItem.Enabled = MainFormManager.MainForm.Views.FirstOrDefault() != null;
+    }
+
     public override void Execute() {
-      Actions.SaveAllAction.Execute();
+      FileManager.SaveAll();
     }
   }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/ToolBarItems/SaveToolBarItem.cs	(revision 2546)
@@ -8,25 +8,32 @@
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
 
 namespace HeuristicLab.Optimizer {
-  public class SaveToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
+  internal class SaveToolBarItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, IOptimizerUserInterfaceItemProvider {
     public override string Name {
       get { return "Save"; }
     }
-
     public override string ToolTipText {
       get { return "Save File (Ctrl + S)"; }
     }
-
     public override int Position {
       get { return 30; }
     }
-
     public override Image Image {
       get { return Resources.SaveIcon; }
     }
 
+    public override void MainFormInitialized(object sender, EventArgs e) {
+      ToolStripItem.Enabled = false;
+    }
+    public override void ActiveViewChanged(object sender, EventArgs e) {
+      IItemView activeView = MainFormManager.MainForm.ActiveView as IItemView;
+      ToolStripItem.Enabled = ((activeView != null) && (CreatableAttribute.IsCreatable(activeView.Item.GetType())));
+    }
+
     public override void Execute() {
-      Actions.SaveAction.Execute();
+      FileManager.Save();
     }
   }
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPInjectorView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPInjectorView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPInjectorView.cs	(revision 2546)
@@ -38,5 +38,5 @@
   /// </summary>
   [Content(typeof(TSPInjector), true)]
-  public partial class TSPInjectorView : ViewBase {
+  public partial class TSPInjectorView : ItemViewBase {
     /// <summary>
     /// Gets or set the <see cref="TSPInjector"/> to represent visually.
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPTourView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPTourView.cs	(revision 2545)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPTourView.cs	(revision 2546)
@@ -39,5 +39,5 @@
   /// </summary>
   [Content(typeof(TSPTour), true)]
-  public partial class TSPTourView : ViewBase {
+  public partial class TSPTourView : ItemViewBase {
     /// <summary>
     /// Gets or sets the <see cref="TSPTour"/> to represent visually.
Index: /trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj	(revision 2545)
+++ /trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.3.csproj	(revision 2546)
@@ -87,9 +87,9 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="SGA.cs" />
-    <Compile Include="SGAEditor.cs">
+    <Compile Include="SGAView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="SGAEditor.Designer.cs">
-      <DependentUpon>SGAEditor.cs</DependentUpon>
+    <Compile Include="SGAView.Designer.cs">
+      <DependentUpon>SGAView.cs</DependentUpon>
     </Compile>
   </ItemGroup>
@@ -157,7 +157,6 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="SGAEditor.resx">
-      <SubType>Designer</SubType>
-      <DependentUpon>SGAEditor.cs</DependentUpon>
+    <EmbeddedResource Include="SGAView.resx">
+      <DependentUpon>SGAView.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
